
/**
 *  gl_caadeff0e205f34d65b5cc6e418c5266d9_nestml.h
 *
 *  This file is part of NEST.
 *
 *  Copyright (C) 2004 The NEST Initiative
 *
 *  NEST is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  NEST is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with NEST.  If not, see <http://www.gnu.org/licenses/>.
 *
 *  Generated from NESTML at time: 2024-02-26 10:00:26.618644
**/
#ifndef GL_CAADEFF0E205F34D65B5CC6E418C5266D9_NESTML
#define GL_CAADEFF0E205F34D65B5CC6E418C5266D9_NESTML

#ifndef HAVE_LIBLTDL
#error "NEST was compiled without support for dynamic loading. Please install libltdl and recompile NEST."
#endif

// C++ includes:
#include <cmath>

#include "config.h"

// Includes from nestkernel:
#include "structural_plasticity_node.h"
#include "connection.h"
#include "dict_util.h"
#include "event.h"
#include "nest_types.h"
#include "ring_buffer.h"
#include "universal_data_logger.h"

// Includes from sli:
#include "dictdatum.h"

namespace nest
{
namespace gl_caadeff0e205f34d65b5cc6e418c5266d9_nestml_names
{
    const Name _U( "U" );
    const Name _a( "a" );
    const Name _alpha_over_N( "alpha_over_N" );
    const Name _beta( "beta" );
    const Name _reset_after_spike( "reset_after_spike" );
}
}




#include "nest_time.h"
  typedef size_t nest_port_t;
  typedef size_t nest_rport_t;

/* BeginDocumentation
  Name: gl_caadeff0e205f34d65b5cc6e418c5266d9_nestml

  Description:

    

  Parameters:
  The following parameters can be set in the status dictionary.
alpha_over_N [real]  synaptic strength
beta [real]  membrane potential leak


  Dynamic state variables:
U [real]  membrane potential


  Sends: nest::SpikeEvent

  Receives: Spike,  DataLoggingRequest
*/
class gl_caadeff0e205f34d65b5cc6e418c5266d9_nestml : public nest::StructuralPlasticityNode
{
public:
  /**
   * The constructor is only used to create the model prototype in the model manager.
  **/
  gl_caadeff0e205f34d65b5cc6e418c5266d9_nestml();

  /**
   * The copy constructor is used to create model copies and instances of the model.
   * @node The copy constructor needs to initialize the parameters and the state.
   *       Initialization of buffers and interal variables is deferred to
   *       @c init_buffers_() and @c pre_run_hook() (or calibrate() in NEST 3.3 and older).
  **/
  gl_caadeff0e205f34d65b5cc6e418c5266d9_nestml(const gl_caadeff0e205f34d65b5cc6e418c5266d9_nestml &);

  /**
   * Destructor.
  **/
  ~gl_caadeff0e205f34d65b5cc6e418c5266d9_nestml() override;

  // -------------------------------------------------------------------------
  //   Import sets of overloaded virtual functions.
  //   See: Technical Issues / Virtual Functions: Overriding, Overloading,
  //        and Hiding
  // -------------------------------------------------------------------------

  using nest::Node::handles_test_event;
  using nest::Node::handle;

  /**
   * Used to validate that we can send nest::SpikeEvent to desired target:port.
  **/
  nest_port_t send_test_event(nest::Node& target, nest_rport_t receptor_type, nest::synindex, bool) override;


  // -------------------------------------------------------------------------
  //   Functions handling incoming events.
  //   We tell nest that we can handle incoming events of various types by
  //   defining handle() for the given event.
  // -------------------------------------------------------------------------


  void handle(nest::SpikeEvent &) override;        //! accept spikes

  void handle(nest::DataLoggingRequest &) override;//! allow recording with multimeter
  nest_port_t handles_test_event(nest::SpikeEvent&, nest_port_t) override;
  nest_port_t handles_test_event(nest::DataLoggingRequest&, nest_port_t) override;

  // -------------------------------------------------------------------------
  //   Functions for getting/setting parameters and state values.
  // -------------------------------------------------------------------------

  void get_status(DictionaryDatum &) const override;
  void set_status(const DictionaryDatum &) override;


  // -------------------------------------------------------------------------
  //   Getters/setters for state block
  // -------------------------------------------------------------------------

  inline double get_U() const
  {
    return S_.U;
  }

  inline void set_U(const double __v)
  {
    S_.U = __v;
  }


  // -------------------------------------------------------------------------
  //   Getters/setters for parameters
  // -------------------------------------------------------------------------

  inline double get_a() const
  {
    return P_.a;
  }

  inline void set_a(const double __v)
  {
    P_.a = __v;
  }

  inline double get_alpha_over_N() const
  {
    return P_.alpha_over_N;
  }

  inline void set_alpha_over_N(const double __v)
  {
    P_.alpha_over_N = __v;
  }

  inline double get_beta() const
  {
    return P_.beta;
  }

  inline void set_beta(const double __v)
  {
    P_.beta = __v;
  }

  inline bool get_reset_after_spike() const
  {
    return P_.reset_after_spike;
  }

  inline void set_reset_after_spike(const bool __v)
  {
    P_.reset_after_spike = __v;
  }


  // -------------------------------------------------------------------------
  //   Getters/setters for internals
  // -------------------------------------------------------------------------

  inline double get___h() const
  {
    return V_.__h;
  }

  inline void set___h(const double __v)
  {
    V_.__h = __v;
  }
  inline double get___P__U__U() const
  {
    return V_.__P__U__U;
  }

  inline void set___P__U__U(const double __v)
  {
    V_.__P__U__U = __v;
  }


  // -------------------------------------------------------------------------
  //   Initialization functions
  // -------------------------------------------------------------------------
  void calibrate_time( const nest::TimeConverter& tc ) override;

protected:

private:
  void recompute_internal_variables(bool exclude_timestep=false);

private:

  static const nest_port_t MIN_SPIKE_RECEPTOR = 0;
  static const nest_port_t PORT_NOT_AVAILABLE = -1;

  enum SynapseTypes
  {
    INCOMING_SPIKES = 0,
    MAX_SPIKE_RECEPTOR = 1
  };

  static const size_t NUM_SPIKE_RECEPTORS = MAX_SPIKE_RECEPTOR - MIN_SPIKE_RECEPTOR;



  /**
   * Reset state of neuron.
  **/

  void init_state_internal_();

  /**
   * Reset internal buffers of neuron.
  **/
  void init_buffers_() override;

  /**
   * Initialize auxiliary quantities, leave parameters and state untouched.
  **/
  void pre_run_hook() override;

  /**
   * Take neuron through given time interval
  **/
  void update(nest::Time const &, const long, const long) override;

  // The next two classes need to be friends to access the State_ class/member
  friend class nest::RecordablesMap<gl_caadeff0e205f34d65b5cc6e418c5266d9_nestml>;
  friend class nest::UniversalDataLogger<gl_caadeff0e205f34d65b5cc6e418c5266d9_nestml>;

  /**
   * Free parameters of the neuron.
   *


   *
   * These are the parameters that can be set by the user through @c `node.set()`.
   * They are initialized from the model prototype when the node is created.
   * Parameters do not change during calls to @c update() and are not reset by
   * @c ResetNetwork.
   *
   * @note Parameters_ need neither copy constructor nor @c operator=(), since
   *       all its members are copied properly by the default copy constructor
   *       and assignment operator. Important:
   *       - If Parameters_ contained @c Time members, you need to define the
   *         assignment operator to recalibrate all members of type @c Time . You
   *         may also want to define the assignment operator.
   *       - If Parameters_ contained members that cannot copy themselves, such
   *         as C-style arrays, you need to define the copy constructor and
   *         assignment operator to copy those members.
  **/
  struct Parameters_
  {    
    double a;
    //!  synaptic strength
    double alpha_over_N;
    //!  membrane potential leak
    double beta;
    bool reset_after_spike;

    /**
     * Initialize parameters to their default values.
    **/
    Parameters_();
  };

  /**
   * Dynamic state of the neuron.
   *
   *
   *
   * These are the state variables that are advanced in time by calls to
   * @c update(). In many models, some or all of them can be set by the user
   * through @c `node.set()`. The state variables are initialized from the model
   * prototype when the node is created. State variables are reset by @c ResetNetwork.
   *
   * @note State_ need neither copy constructor nor @c operator=(), since
   *       all its members are copied properly by the default copy constructor
   *       and assignment operator. Important:
   *       - If State_ contained @c Time members, you need to define the
   *         assignment operator to recalibrate all members of type @c Time . You
   *         may also want to define the assignment operator.
   *       - If State_ contained members that cannot copy themselves, such
   *         as C-style arrays, you need to define the copy constructor and
   *         assignment operator to copy those members.
  **/
  struct State_
  {    
    //!  membrane potential
    double U;

    State_();
  };

  struct DelayedVariables_
  {
  };

  /**
   * Internal variables of the neuron.
   *
   *
   *
   * These variables must be initialized by @c pre_run_hook (or calibrate in NEST 3.3 and older), which is called before
   * the first call to @c update() upon each call to @c Simulate.
   * @node Variables_ needs neither constructor, copy constructor or assignment operator,
   *       since it is initialized by @c pre_run_hook() (or calibrate() in NEST 3.3 and older). If Variables_ has members that
   *       cannot destroy themselves, Variables_ will need a destructor.
  **/
  struct Variables_
  {
    double __h;
    double __P__U__U;
  };

  /**
   * Buffers of the neuron.
   * Usually buffers for incoming spikes and data logged for analog recorders.
   * Buffers must be initialized by @c init_buffers_(), which is called before
   * @c pre_run_hook() (or calibrate() in NEST 3.3 and older) on the first call to @c Simulate after the start of NEST,
   * ResetKernel or ResetNetwork.
   * @node Buffers_ needs neither constructor, copy constructor or assignment operator,
   *       since it is initialized by @c init_nodes_(). If Buffers_ has members that
   *       cannot destroy themselves, Buffers_ will need a destructor.
  **/
  struct Buffers_
  {
    Buffers_(gl_caadeff0e205f34d65b5cc6e418c5266d9_nestml &);
    Buffers_(const Buffers_ &, gl_caadeff0e205f34d65b5cc6e418c5266d9_nestml &);

    /**
     * Logger for all analog data
    **/
    nest::UniversalDataLogger<gl_caadeff0e205f34d65b5cc6e418c5266d9_nestml> logger_;

    // -----------------------------------------------------------------------
    //   Buffers and sums of incoming spikes/currents per timestep
    // -----------------------------------------------------------------------
    // Buffer containing the incoming spikes
    

inline std::vector< nest::RingBuffer >& get_spike_inputs_()
{
    return spike_inputs_;
}
std::vector< nest::RingBuffer > spike_inputs_;

    // Buffer containing the sum of all the incoming spikes
    

inline std::vector< double >& get_spike_inputs_grid_sum_()
{
    return spike_inputs_grid_sum_;
}
std::vector< double > spike_inputs_grid_sum_;
  };

  // -------------------------------------------------------------------------
  //   Getters/setters for inline expressions
  // -------------------------------------------------------------------------
  

  // -------------------------------------------------------------------------
  //   Getters/setters for input buffers
  // -------------------------------------------------------------------------

  // Buffer containing the incoming spikes
  

inline std::vector< nest::RingBuffer >& get_spike_inputs_()
{
    return B_.get_spike_inputs_();
}

  

inline std::vector< double >& get_spike_inputs_grid_sum_()
{
    return B_.get_spike_inputs_grid_sum_();
}
  // -------------------------------------------------------------------------
  //   Function declarations
  // -------------------------------------------------------------------------



  //
  double phi ( double U) const;

  // -------------------------------------------------------------------------
  //   Member variables of neuron model.
  //   Each model neuron should have precisely the following four data members,
  //   which are one instance each of the parameters, state, buffers and variables
  //   structures. Experience indicates that the state and variables member should
  //   be next to each other to achieve good efficiency (caching).
  //   Note: Devices require one additional data member, an instance of the
  //   ``Device`` child class they belong to.
  // -------------------------------------------------------------------------


  Parameters_       P_;        //!< Free parameters.
  State_            S_;        //!< Dynamic state.
  DelayedVariables_ DV_;       //!< Delayed state variables.
  Variables_        V_;        //!< Internal Variables
  Buffers_          B_;        //!< Buffers.

  //! Mapping of recordables names to access functions
  static nest::RecordablesMap<gl_caadeff0e205f34d65b5cc6e418c5266d9_nestml> recordablesMap_;

}; /* neuron gl_caadeff0e205f34d65b5cc6e418c5266d9_nestml */

inline nest_port_t gl_caadeff0e205f34d65b5cc6e418c5266d9_nestml::send_test_event(nest::Node& target, nest_rport_t receptor_type, nest::synindex, bool)
{
  // You should usually not change the code in this function.
  // It confirms that the target of connection @c c accepts @c nest::SpikeEvent on
  // the given @c receptor_type.
  nest::SpikeEvent e;
  e.set_sender(*this);
  return target.handles_test_event(e, receptor_type);
}

inline nest_port_t gl_caadeff0e205f34d65b5cc6e418c5266d9_nestml::handles_test_event(nest::SpikeEvent&, nest_port_t receptor_type)
{
    // You should usually not change the code in this function.
    // It confirms to the connection management system that we are able
    // to handle @c SpikeEvent on port 0. You need to extend the function
    // if you want to differentiate between input ports.
    if (receptor_type != 0)
    {
      throw nest::UnknownReceptorType(receptor_type, get_name());
    }
    return 0;
}

inline nest_port_t gl_caadeff0e205f34d65b5cc6e418c5266d9_nestml::handles_test_event(nest::DataLoggingRequest& dlr, nest_port_t receptor_type)
{
  // You should usually not change the code in this function.
  // It confirms to the connection management system that we are able
  // to handle @c DataLoggingRequest on port 0.
  // The function also tells the built-in UniversalDataLogger that this node
  // is recorded from and that it thus needs to collect data during simulation.
  if (receptor_type != 0)
  {
    throw nest::UnknownReceptorType(receptor_type, get_name());
  }

  return B_.logger_.connect_logging_device(dlr, recordablesMap_);
}

inline void gl_caadeff0e205f34d65b5cc6e418c5266d9_nestml::get_status(DictionaryDatum &__d) const
{
  // parameters
  def<double>(__d, nest::gl_caadeff0e205f34d65b5cc6e418c5266d9_nestml_names::_a, get_a());
  def<double>(__d, nest::gl_caadeff0e205f34d65b5cc6e418c5266d9_nestml_names::_alpha_over_N, get_alpha_over_N());
  def<double>(__d, nest::gl_caadeff0e205f34d65b5cc6e418c5266d9_nestml_names::_beta, get_beta());
  def<bool>(__d, nest::gl_caadeff0e205f34d65b5cc6e418c5266d9_nestml_names::_reset_after_spike, get_reset_after_spike());

  // initial values for state variables in ODE or kernel
  def<double>(__d, nest::gl_caadeff0e205f34d65b5cc6e418c5266d9_nestml_names::_U, get_U());

  StructuralPlasticityNode::get_status( __d );

  (*__d)[nest::names::recordables] = recordablesMap_.get_list();
}

inline void gl_caadeff0e205f34d65b5cc6e418c5266d9_nestml::set_status(const DictionaryDatum &__d)
{
  // parameters
  double tmp_a = get_a();
  nest::updateValueParam<double>(__d, nest::gl_caadeff0e205f34d65b5cc6e418c5266d9_nestml_names::_a, tmp_a, this);
  double tmp_alpha_over_N = get_alpha_over_N();
  nest::updateValueParam<double>(__d, nest::gl_caadeff0e205f34d65b5cc6e418c5266d9_nestml_names::_alpha_over_N, tmp_alpha_over_N, this);
  double tmp_beta = get_beta();
  nest::updateValueParam<double>(__d, nest::gl_caadeff0e205f34d65b5cc6e418c5266d9_nestml_names::_beta, tmp_beta, this);
  bool tmp_reset_after_spike = get_reset_after_spike();
  nest::updateValueParam<bool>(__d, nest::gl_caadeff0e205f34d65b5cc6e418c5266d9_nestml_names::_reset_after_spike, tmp_reset_after_spike, this);

  // initial values for state variables in ODE or kernel
  double tmp_U = get_U();
  nest::updateValueParam<double>(__d, nest::gl_caadeff0e205f34d65b5cc6e418c5266d9_nestml_names::_U, tmp_U, this);

  // We now know that (ptmp, stmp) are consistent. We do not
  // write them back to (P_, S_) before we are also sure that
  // the properties to be set in the parent class are internally
  // consistent.
  StructuralPlasticityNode::set_status(__d);

  // if we get here, temporaries contain consistent set of properties
  set_a(tmp_a);
  set_alpha_over_N(tmp_alpha_over_N);
  set_beta(tmp_beta);
  set_reset_after_spike(tmp_reset_after_spike);
  set_U(tmp_U);





  // recompute internal variables in case they are dependent on parameters or state that might have been updated in this call to set_status()
  recompute_internal_variables();
};



#endif /* #ifndef GL_CAADEFF0E205F34D65B5CC6E418C5266D9_NESTML */
